<?php

/*
  API v2.0.0
  News App - WRTeam.in
  WRTeam Developers
 */

namespace App\Controllers;

use CodeIgniter\RESTful\ResourceController;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;
use \Firebase\JWT\JWT;

class Api extends ResourceController {

    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger) {
        // Do Not Edit This Line
        parent::initController($request, $response, $logger);
        $this->db = \Config\Database::connect();
        $this->access_key = "5670";

        $res = $this->db->table('tbl_settings')->where('type', 'jwt_key')->get()->getResult();
        $this->JWT_KEY = (!empty($res)) ? $res[0]->message : "";

        $this->helpers = helper('SystemSettings');
        date_default_timezone_set(get_system_timezone());
        $this->toDateTime = date('Y-m-d H:i:s');
    }

    public function get_user_notification() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id')) {
                $user_id = $this->request->getVar('user_id');

                $offset = ($this->request->getVar('offset')) ? $this->request->getVar('offset') : 0;
                $limit = ($this->request->getVar('limit')) ? $this->request->getVar('limit') : 10;

                $res = $this->db->table('tbl_comment_notification');
                $res->where('user_id', $user_id);
                $res->limit($limit, $offset)->orderBy('id', 'DESC');
                $data = $res->get()->getResult();
                if ($data) {
                    $res = $this->db->table('tbl_comment_notification');
                    $res->where('user_id', $user_id);
                    $data1 = $res->get()->getResult();
                    $total = count($data1);

                    $response['error'] = "false";
                    $response['total'] = "$total";
                    $response['data'] = $data;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function delete_user_notification() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('id')) {

                $comment_notification_id = $this->request->getVar('id');

                $this->db->table('tbl_comment_notification')->whereIn('id', explode(",", $comment_notification_id))->delete();
                $response['error'] = "false";
                $response['message'] = "Notification deleted!";
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function get_news_by_tag() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('tag_id') && $this->request->getVar('user_id') != '') {
                $tag_id = $this->request->getVar('tag_id');
                $user_id = $this->request->getVar('user_id');

                $offset = ($this->request->getVar('offset')) ? $this->request->getVar('offset') : 0;
                $limit = ($this->request->getVar('limit')) ? $this->request->getVar('limit') : 10;

                $join = ' LEFT JOIN tbl_category ON tbl_category.id = tbl_news.category_id';
                $join .= ' LEFT JOIN tbl_subcategory ON tbl_subcategory.id = tbl_news.subcategory_id';

                $where = ' WHERE instr(tag_id, ' . $tag_id . ')';

                $query = $this->db->query('SELECT tbl_news.*, tbl_category.category_name, tbl_subcategory.subcategory_name FROM tbl_news' . $join . ' ' . $where . ' ORDER BY id DESC LIMIT ' . $offset . ',' . $limit . '');
                $data = $query->getResult();
                if ($data) {
                    $query1 = $this->db->query('SELECT tbl_news.*, tbl_category.category_name, tbl_subcategory.subcategory_name FROM tbl_news ' . $join . ' ' . $where . ' ORDER BY id DESC');
                    $data1 = $query1->getResult();
                    $total = count($data1);
                    for ($i = 0; $i < count($data); $i++) {
                        $data[$i]->image = ($data[$i]->image) ? base_url() . '/public/images/news/' . $data[$i]->image : '';
                        if ($data[$i]->content_type == "video_upload") {
                            $data[$i]->content_value = ($data[$i]->content_value) ? base_url() . '/public/images/news_video/' . $data[$i]->content_value : '';
                        }
                        $img = array();
                        $img = $this->db->table('tbl_news_image')->select('other_image')->where('news_id', $data[$i]->id)->get()->getResult();
                        for ($j = 0; $j < count($img); $j++) {
                            $img[$j]->other_image = ($img[$j]->other_image) ? base_url() . '/public/images/news/' . $data[$i]->id . '/' . $img[$j]->other_image : '';
                        }
                        $data[$i]->image_data = $img;

                        $like = $this->db->table('tbl_news_like')->select('COUNT(id) as total')->where('news_id', $data[$i]->id)->where('status', '1')->get()->getResult();
                        $data[$i]->total_like = (!empty($like)) ? $like[0]->total : "0";

                        $dislike = $this->db->table('tbl_news_like')->select('COUNT(id) as total')->where('news_id', $data[$i]->id)->where('status', '2')->get()->getResult();
                        $data[$i]->total_dislike = (!empty($dislike)) ? $dislike[0]->total : "0";

                        $ulike = $this->db->table('tbl_news_like')->where('news_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '1')->get()->getResult();
                        $data[$i]->like = (!empty($ulike)) ? '1' : '0';

                        $udislike = $this->db->table('tbl_news_like')->where('news_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '2')->get()->getResult();
                        $data[$i]->dislike = (!empty($udislike)) ? '1' : '0';

                        $query2 = $this->db->query('SELECT GROUP_CONCAT(distinct(tag_name)) as tag_name FROM tbl_tag WHERE id IN(' . $data[$i]->tag_id . ')');
                        $res2 = $query2->getResult();
                        $data[$i]->tag_name = (!empty($res2)) ? $res2[0]->tag_name : '';
                    }
                    $response['error'] = "false";
                    $response['total'] = "$total";
                    $response['data'] = $data;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function get_subcategory_by_category() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('category_id')) {
                $category_id = $this->request->getVar('category_id');

                $res = $this->db->table('tbl_subcategory');
                $res->select('tbl_subcategory.*, tbl_category.category_name');
                $res->join('tbl_category', 'tbl_category.id = tbl_subcategory.category_id');
                $res->where('tbl_subcategory.category_id', $category_id);
                $data = $res->get()->getResult();
                if ($data) {
                    for ($i = 0; $i < count($data); $i++) {
                        $data[$i]->image = ($data[$i]->image) ? base_url() . '/public/images/subcategory/' . $data[$i]->image : '';
                    }
                    $response['error'] = "false";
                    $response['data'] = $data;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function set_comment_like_dislike() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id') && $this->request->getVar('comment_id') && $this->request->getVar('status') != '') {
                $user_id = $this->request->getVar('user_id');
                $comment_id = $this->request->getVar('comment_id');
                $status = $this->request->getVar('status');

                if ($status != '0') {
                    $res = $this->db->table('tbl_comment_like')->where('comment_id', $comment_id)->where('user_id', $user_id)->get()->getResult();
                    if (!empty($res)) {
                        $data = array(
                            'status' => $status
                        );
                        $this->db->table('tbl_comment_like')->where('comment_id', $comment_id)->where('user_id', $user_id)->update($data);
                    } else {
                        $data = [
                            'user_id' => $user_id,
                            'comment_id' => $comment_id,
                            'status' => $status
                        ];
                        $this->db->table('tbl_comment_like')->insert($data);
                        $insert_id = $this->db->insertID();
                    }
                    if ($status == '1') {
                        $res_comment = $this->db->table('tbl_comment_like')->where('id', $insert_id)->get()->getResult();

                        if (!empty($res_comment)) {
                            $comment_id = $res_comment[0]->comment_id;
                            $res_comment1 = $this->db->table('tbl_comment')->where('id', $comment_id)->get()->getResult();
                            if ($comment_id) {

                                $old_user_id = $res_comment1[0]->user_id;
                                $res1 = $this->db->table('tbl_users')->where('id', $old_user_id)->get()->getResult();
                                if (!empty($res1)) {

                                    $get_name = $this->db->table('tbl_users')->where('id', $user_id)->get()->getResult();
                                    $fcmMsg = array(
                                        'click_action' => 'FLUTTER_NOTIFICATION_CLICK',
                                        'type' => 'comment_like',
//                                        'comment_like_id' => $id,
//                                            'message' => $get_name[0]->name . ' liked your comment',
                                        'message' => 'Like in your comment in ' . $res_comment[0]->message . ' by ' . $get_name[0]->name,
                                    );

                                    $fcm_id = ($res1[0]->fcm_id) ? $res1[0]->fcm_id : "";
                                    $fcmFields = array(
                                        'to' => $fcm_id,
                                        'priority' => 'high',
                                        'notification' => $fcmMsg,
                                        'data' => $fcmMsg
                                    );

                                    $res2 = $this->db->table('tbl_settings')->where('type', 'fcm_sever_key')->get()->getResult();
                                    $API_ACCESS_KEY = (!empty($res2)) ? $res2[0]->message : '';

                                    $headers = array(
                                        'Authorization: key=' . $API_ACCESS_KEY,
                                        'Content-Type: application/json'
                                    );

                                    $ch = curl_init();
                                    curl_setopt($ch, CURLOPT_URL, 'https://fcm.googleapis.com/fcm/send');
                                    curl_setopt($ch, CURLOPT_POST, true);
                                    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                                    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
                                    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fcmFields));
                                    $result = curl_exec($ch);

                                    if ($result === FALSE) {
                                        die('Curl failed: ' . curl_error($ch));
                                    }
                                    //Now close the connection
                                    curl_close($ch);

                                    $like_data = [
                                        'master_id' => $insert_id,
                                        'user_id' => $old_user_id,
                                        'sender_id' => $user_id,
                                        'type' => 'comment_like',
//                                            'message' => $get_name[0]->name . ' liked your comment',
                                        'message' => 'Like in your comment in ' . $res_comment1[0]->message . ' by ' . $get_name[0]->name,
                                        'date' => $this->toDateTime
                                    ];
                                    $this->db->table('tbl_comment_notification')->insert($like_data);
                                }
                            }
                        }
                    }
                } else {
                    $this->db->table('tbl_comment_like')->where('comment_id', $comment_id)->where('user_id', $user_id)->delete();
                }

                $response['error'] = "false";
                $response['message'] = "updated successfully!";
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function get_live_streaming() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            $data = $this->db->table('tbl_live_streaming')->orderBy('id', 'DESC')->get()->getResult();
            if ($data) {
                $response['error'] = "false";
                $response['data'] = $data;
            } else {
                $response['error'] = "true";
                $response['message'] = "No Data Found";
            }
        }
        return $this->respond($response);
    }

    public function set_flag() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('comment_id') && $this->request->getVar('user_id') && $this->request->getVar('news_id') && $this->request->getVar('message')) {

                $user_id = $this->request->getVar('user_id');
                $news_id = $this->request->getVar('news_id');
                $comment_id = $this->request->getVar('comment_id');
                $message = $this->request->getVar('message');
                $status = '1';

                $data = [
                    'comment_id' => $comment_id,
                    'user_id' => $user_id,
                    'news_id' => $news_id,
                    'message' => $message,
                    'status' => $status,
                    'date' => $this->toDateTime
                ];
                $this->db->table('tbl_comment_flag')->insert($data);

                $response['error'] = "false";
                $response['message'] = "flag successfully";
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function set_like_dislike() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id') && $this->request->getVar('news_id') && $this->request->getVar('status') != '') {
                $user_id = $this->request->getVar('user_id');
                $news_id = $this->request->getVar('news_id');
                $status = $this->request->getVar('status');

                if ($status != '0') {
                    $res = $this->db->table('tbl_news_like')->where('news_id', $news_id)->where('user_id', $user_id)->get()->getResult();
                    if (!empty($res)) {
                        $data = array(
                            'status' => $status
                        );
                        $this->db->table('tbl_news_like')->where('news_id', $news_id)->where('user_id', $user_id)->update($data);
                    } else {
                        $data = [
                            'user_id' => $user_id,
                            'news_id' => $news_id,
                            'status' => $status
                        ];
                        $this->db->table('tbl_news_like')->insert($data);
                    }
                } else {
                    $this->db->table('tbl_news_like')->where('news_id', $news_id)->where('user_id', $user_id)->delete();
                }

                $response['error'] = "false";
                $response['message'] = "updated successfully!";
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function get_news_by_user_category() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id') && $this->request->getVar('category_id')) {
                $category_id = $this->request->getVar('category_id');
                $user_id = $this->request->getVar('user_id');

                $offset = ($this->request->getVar('offset')) ? $this->request->getVar('offset') : 0;
                $limit = ($this->request->getVar('limit')) ? $this->request->getVar('limit') : 10;

                $data = $this->db->query("SELECT n.*,c.category_name FROM tbl_news n JOIN tbl_category c ON n.category_id = c.id WHERE n.category_id IN ($category_id)  ORDER BY rand() LIMIT $offset, $limit")->getResult();

                if ($data) {
                    $data1 = $this->db->query("SELECT n.*,c.category_name FROM tbl_news n JOIN tbl_category c ON n.category_id = c.id WHERE n.category_id IN ($category_id)")->getResult();
                    $total = count($data1);
                    for ($i = 0; $i < count($data); $i++) {
                        $data[$i]->image = ($data[$i]->image) ? base_url() . '/public/images/news/' . $data[$i]->image : '';
                        if ($data[$i]->content_type == "video_upload") {
                            $data[$i]->content_value = ($data[$i]->content_value) ? base_url() . '/public/images/news_video/' . $data[$i]->content_value : '';
                        }
                        $img = array();
                        $img = $this->db->table('tbl_news_image')->select('other_image')->where('news_id', $data[$i]->id)->get()->getResult();
                        for ($j = 0; $j < count($img); $j++) {
                            $img[$j]->other_image = ($img[$j]->other_image) ? base_url() . '/public/images/news/' . $data[$i]->id . '/' . $img[$j]->other_image : '';
                        }
                        $data[$i]->image_data = $img;

                        $like = $this->db->table('tbl_news_like')->select('COUNT(id) as total')->where('news_id', $data[$i]->id)->where('status', '1')->get()->getResult();
                        $data[$i]->total_like = (!empty($like)) ? $like[0]->total : "0";

                        $dislike = $this->db->table('tbl_news_like')->select('COUNT(id) as total')->where('news_id', $data[$i]->id)->where('status', '2')->get()->getResult();
                        $data[$i]->total_dislike = (!empty($dislike)) ? $dislike[0]->total : "0";

                        $ulike = $this->db->table('tbl_news_like')->where('news_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '1')->get()->getResult();
                        $data[$i]->like = (!empty($ulike)) ? '1' : '0';

                        $udislike = $this->db->table('tbl_news_like')->where('news_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '2')->get()->getResult();
                        $data[$i]->dislike = (!empty($udislike)) ? '1' : '0';

                        $query2 = $this->db->query('SELECT GROUP_CONCAT(distinct(tag_name)) as tag_name FROM tbl_tag WHERE id IN(' . $data[$i]->tag_id . ')');
                        $res2 = $query2->getResult();
                        $data[$i]->tag_name = (!empty($res2)) ? $res2[0]->tag_name : '';
                    }
                    $response['error'] = "false";
                    $response['total'] = "$total";
                    $response['data'] = $data;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function set_user_category() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id') && $this->request->getVar('category_id') != '') {
                $user_id = $this->request->getVar('user_id');
                $category_id = $this->request->getVar('category_id');
                if ($category_id == '0') {
                    $this->db->table('tbl_users_category')->where('user_id', $user_id)->delete();
                } else {
                    $res = $this->db->table('tbl_users_category')->where('user_id', $user_id)->get()->getResult();
                    if (!empty($res)) {
                        $data = ['category_id' => $category_id];
                        $this->db->table('tbl_users_category')->where('user_id', $user_id)->update($data);
                    } else {
                        $data = [
                            'user_id' => $user_id,
                            'category_id' => $category_id,
                        ];
                        $this->db->table('tbl_users_category')->insert($data);
                    }
                }
                $response['error'] = "false";
                $response['message'] = "updated successfully";
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function get_notification() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            $offset = ($this->request->getVar('offset')) ? $this->request->getVar('offset') : 0;
            $limit = ($this->request->getVar('limit')) ? $this->request->getVar('limit') : 10;

            $res = $this->db->table('tbl_notifications');
            $res->select('tbl_notifications.*,tbl_category.category_name, tbl_news.title as new_title');
            $res->join('tbl_category', 'tbl_category.id = tbl_notifications.category_id', 'left');
            $res->join('tbl_news', 'tbl_news.id = tbl_notifications.news_id', 'left');
            $res->limit($limit, $offset)->orderBy('tbl_notifications.id', 'DESC');
            $data = $res->get()->getResult();
            if ($data) {
                $res = $this->db->table('tbl_notifications');
                $res->select('tbl_notifications.*,tbl_category.category_name');
                $res->join('tbl_category', 'tbl_category.id = tbl_notifications.category_id', 'left');
                $res->join('tbl_news', 'tbl_news.id = tbl_notifications.news_id', 'left');
                $data1 = $res->get()->getResult();
                $total = count($data1);
                for ($i = 0; $i < count($data); $i++) {
                    $data[$i]->image = ($data[$i]->image) ? base_url() . '/public/images/notification/' . $data[$i]->image : '';

                    $data[$i]->category_name = ($data[$i]->category_name != NULL) ? $data[$i]->category_name : '';
                    $data[$i]->new_title = ($data[$i]->new_title != NULL) ? $data[$i]->new_title : '';
                }
                $response['error'] = "false";
                $response['total'] = "$total";
                $response['data'] = $data;
            } else {
                $response['error'] = "true";
                $response['message'] = "No Data Found";
            }
        }
        return $this->respond($response);
    }

    public function get_bookmark() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id')) {
                $user_id = $this->request->getVar('user_id');

                $offset = ($this->request->getVar('offset')) ? $this->request->getVar('offset') : 0;
                $limit = ($this->request->getVar('limit')) ? $this->request->getVar('limit') : 10;

                $res = $this->db->table('tbl_bookmark b');
                $res->select('b.*,n.category_id,c.category_name,n.title,n.date,n.tag_id,n.content_type,n.content_value,n.image,n.description');
                $res->join('tbl_news n', 'n.id = b.news_id');
                $res->join('tbl_category c', 'c.id = n.category_id');
                $res->where('user_id', $user_id)->limit($limit, $offset)->orderBy('id', 'DESC');
                $data = $res->get()->getResult();
                if ($data) {
                    $res = $this->db->table('tbl_bookmark b');
                    $res->select('b.*,n.category_id,c.category_name,n.title,n.date,n.content_type,n.content_value,n.image,n.description');
                    $res->join('tbl_news n', 'n.id = b.news_id');
                    $res->join('tbl_category c', 'c.id = n.category_id');
                    $res->where('user_id', $user_id);
                    $data1 = $res->get()->getResult();
                    $total = count($data1);

                    for ($i = 0; $i < count($data); $i++) {
                        $data[$i]->image = ($data[$i]->image) ? base_url() . '/public/images/news/' . $data[$i]->image : '';
                        if ($data[$i]->content_type == "video_upload") {
                            $data[$i]->content_value = ($data[$i]->content_value) ? base_url() . '/public/images/news_video/' . $data[$i]->content_value : '';
                        }
                        $img = array();
                        $img = $this->db->table('tbl_news_image')->select('other_image')->where('news_id', $data[$i]->news_id)->get()->getResult();
                        for ($j = 0; $j < count($img); $j++) {
                            $img[$j]->other_image = ($img[$j]->other_image) ? base_url() . '/public/images/news/' . $data[$i]->news_id . '/' . $img[$j]->other_image : '';
                        }
                        $data[$i]->image_data = $img;

                        $like = $this->db->table('tbl_news_like')->select('COUNT(id) as total')->where('news_id', $data[$i]->news_id)->where('status', '1')->get()->getResult();
                        $data[$i]->total_like = (!empty($like)) ? $like[0]->total : "0";

                        $dislike = $this->db->table('tbl_news_like')->select('COUNT(id) as total')->where('news_id', $data[$i]->news_id)->where('status', '2')->get()->getResult();
                        $data[$i]->total_dislike = (!empty($dislike)) ? $dislike[0]->total : "0";

                        $ulike = $this->db->table('tbl_news_like')->where('news_id', $data[$i]->news_id)->where('user_id', $user_id)->where('status', '1')->get()->getResult();
                        $data[$i]->like = (!empty($ulike)) ? '1' : '0';

                        $udislike = $this->db->table('tbl_news_like')->where('news_id', $data[$i]->news_id)->where('user_id', $user_id)->where('status', '2')->get()->getResult();
                        $data[$i]->dislike = (!empty($udislike)) ? '1' : '0';

                        $query2 = $this->db->query('SELECT GROUP_CONCAT(distinct(tag_name)) as tag_name FROM tbl_tag WHERE id IN(' . $data[$i]->tag_id . ')');
                        $res2 = $query2->getResult();
                        $data[$i]->tag_name = (!empty($res2)) ? $res2[0]->tag_name : '';
                    }
                    $response['error'] = "false";
                    $response['total'] = "$total";
                    $response['data'] = $data;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function set_bookmark() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id') && $this->request->getVar('news_id') && $this->request->getVar('status') != '') {
                $user_id = $this->request->getVar('user_id');
                $news_id = $this->request->getVar('news_id');
                $status = $this->request->getVar('status');

                if ($status == '1') {
                    $data = $this->db->table('tbl_bookmark')->where('user_id', $user_id)->where('news_id', $news_id)->get()->getResult();
                    if (empty($data)) {
                        $data = [
                            'user_id' => $user_id,
                            'news_id' => $news_id,
                        ];
                        $this->db->table('tbl_bookmark')->insert($data);
                        $response['error'] = "false";
                        $response['message'] = "bookmark successfully";
                    } else {
                        $response['error'] = "true";
                        $response['message'] = "already bookmark";
                    }
                } else if ($status == '0') {
                    $this->db->table('tbl_bookmark')->where('user_id', $user_id)->where('news_id', $news_id)->delete();
                    $response['error'] = "false";
                    $response['message'] = "bookmark remove successfully";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function delete_comment() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id') && $this->request->getVar('comment_id')) {
                $user_id = $this->request->getVar('user_id');
                $comment_id = $this->request->getVar('comment_id');

                $this->db->table('tbl_comment')->where('id', $comment_id)->where('user_id', $user_id)->delete();
                $response['error'] = "false";
                $response['message'] = "comment deleted!";
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function get_comment_by_news() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('news_id') && $this->request->getVar('user_id') != '') {
                $news_id = $this->request->getVar('news_id');
                $user_id = $this->request->getVar('user_id');

                $offset = ($this->request->getVar('offset')) ? $this->request->getVar('offset') : 0;
                $limit = ($this->request->getVar('limit')) ? $this->request->getVar('limit') : 10;

                $res = $this->db->table('tbl_comment c');
                $res->select('c.*,u.name,u.profile');
                $res->join('tbl_users u', 'u.id = c.user_id');
                $res->where('c.news_id', $news_id)->where('c.parent_id', '0')->where('c.status', '1')->limit($limit, $offset)->orderBy('id', 'DESC');
                $data = $res->get()->getResult();
                if ($data) {
                    for ($i = 0; $i < count($data); $i++) {
                        if (filter_var($data[$i]->profile, FILTER_VALIDATE_URL) === FALSE) {
                            // Not a valid URL. Its a image only or empty
                            $data[$i]->profile = (!empty($data[$i]->profile)) ? base_url() . '/public/images/profile/' . $data[$i]->profile : '';
                        }

                        $tbl = $this->db->table('tbl_comment_like');
                        $like = $tbl->select('COUNT(id) as total')->where('comment_id', $data[$i]->id)->where('status', '1')->get()->getResult();
                        $data[$i]->total_like = (!empty($like)) ? $like[0]->total : "0";

                        $dislike = $tbl->select('COUNT(id) as total')->where('comment_id', $data[$i]->id)->where('status', '2')->get()->getResult();
                        $data[$i]->total_dislike = (!empty($dislike)) ? $dislike[0]->total : "0";

                        $ulike = $tbl->where('comment_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '1')->get()->getResult();
                        $data[$i]->like = (!empty($ulike)) ? '1' : '0';

                        $udislike = $tbl->where('comment_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '2')->get()->getResult();
                        $data[$i]->dislike = (!empty($udislike)) ? '1' : '0';

                        $data[$i]->replay = $data3 = array();
                        $res = $this->db->table('tbl_comment c');
                        $res->select('c.*,u.name,u.profile');
                        $res->join('tbl_users u', 'u.id = c.user_id');
                        $res->where('c.news_id', $news_id)->where('c.parent_id', $data[$i]->id)->where('c.status', '1')->orderBy('id', 'ASC');
                        $data3 = $res->get()->getResult();
                        for ($j = 0; $j < count($data3); $j++) {
                            if (filter_var($data[$j]->profile, FILTER_VALIDATE_URL) === FALSE) {
                                // Not a valid URL. Its a image only or empty
                                $data3[$j]->profile = (!empty($data3[$j]->profile)) ? base_url() . '/public/images/profile/' . $data3[$j]->profile : '';
                            }
                            $like = $tbl->select('COUNT(id) as total')->where('comment_id', $data3[$j]->id)->where('status', '1')->get()->getResult();
                            $data3[$j]->total_like = (!empty($like)) ? $like[0]->total : "0";

                            $dislike = $tbl->select('COUNT(id) as total')->where('comment_id', $data3[$j]->id)->where('status', '2')->get()->getResult();
                            $data3[$j]->total_dislike = (!empty($dislike)) ? $dislike[0]->total : "0";

                            $ulike = $tbl->where('comment_id', $data3[$j]->id)->where('user_id', $user_id)->where('status', '1')->get()->getResult();
                            $data3[$j]->like = (!empty($ulike)) ? '1' : '0';

                            $udislike = $tbl->where('comment_id', $data3[$j]->id)->where('user_id', $user_id)->where('status', '2')->get()->getResult();
                            $data3[$j]->dislike = (!empty($udislike)) ? '1' : '0';
                        }
                        $data[$i]->replay = $data3;
                    }
                    $res = $this->db->table('tbl_comment c');
                    $res->select('c.*, u.name')->join('tbl_users u', 'u.id = c.user_id');
                    $res->where('c.news_id', $news_id)->where('c.status', '1');
                    $data1 = $res->get()->getResult();
                    $total = count($data1);

                    $response['error'] = "false";
                    $response['total'] = "$total";
                    $response['data'] = $data;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function set_comment() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id') && $this->request->getVar('parent_id') != '' && $this->request->getVar('news_id') && $this->request->getVar('message')) {
                $user_id = $this->request->getVar('user_id');
                $parent_id = $this->request->getVar('parent_id');
                $news_id = $this->request->getVar('news_id');
                $message = $this->request->getVar('message');
                $status = '1';

                $data2 = [
                    'user_id' => $user_id,
                    'parent_id' => $parent_id,
                    'news_id' => $news_id,
                    'message' => $message,
                    'status' => $status,
                    'date' => $this->toDateTime
                ];
                $this->db->table('tbl_comment')->insert($data2);
                $insert_id = $this->db->insertID();

                if ($parent_id) {
                    $res = $this->db->table('tbl_comment')->where('id', $parent_id)->get()->getResult();
                    if (!empty($res)) {
                        $old_user_id = $res[0]->user_id;
                        $res1 = $this->db->table('tbl_users')->where('id', $old_user_id)->get()->getResult();
                        if (!empty($res1)) {
                            $get_name = $this->db->table('tbl_users')->where('id', $user_id)->get()->getResult();

                            $fcmMsg = array(
                                'click_action' => 'FLUTTER_NOTIFICATION_CLICK',
                                'type' => 'comment',
                                'news_id' => $news_id,
                                'message' => 'Reply in your comment in ' . $res[0]->message . ' by ' . $get_name[0]->name,
                            );
                            $fcm_id = ($res1[0]->fcm_id) ? $res1[0]->fcm_id : "";
                            $fcmFields = array(
                                'to' => $fcm_id,
                                'priority' => 'high',
                                'notification' => $fcmMsg,
                                'data' => $fcmMsg
                            );

                            $res2 = $this->db->table('tbl_settings')->where('type', 'fcm_sever_key')->get()->getResult();
                            $API_ACCESS_KEY = (!empty($res2)) ? $res2[0]->message : '';

                            $headers = array(
                                'Authorization: key=' . $API_ACCESS_KEY,
                                'Content-Type: application/json'
                            );

                            $ch = curl_init();
                            curl_setopt($ch, CURLOPT_URL, 'https://fcm.googleapis.com/fcm/send');
                            curl_setopt($ch, CURLOPT_POST, true);
                            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
                            curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fcmFields));
                            $result = curl_exec($ch);

                            if ($result === FALSE) {
                                die('Curl failed: ' . curl_error($ch));
                            }
                            curl_close($ch);

                            $notification_comment = [
                                'master_id' => $insert_id,
                                'user_id' => $old_user_id,
                                'sender_id' => $user_id,
                                'type' => 'comment',
                                'message' => 'Reply in your comment in ' . $res[0]->message . ' by ' . $get_name[0]->name,
                                'date' => $this->toDateTime
                            ];
                            $this->db->table('tbl_comment_notification')->insert($notification_comment);
                        }
                    }
                }




                $offset = ($this->request->getVar('offset')) ? $this->request->getVar('offset') : 0;
                $limit = ($this->request->getVar('limit')) ? $this->request->getVar('limit') : 10;

                $res = $this->db->table('tbl_comment c');
                $res->select('c.*,u.name,u.profile');
                $res->join('tbl_users u', 'u.id = c.user_id');
                $res->where('c.news_id', $news_id)->where('c.parent_id', '0')->where('c.status', '1')->limit($limit, $offset)->orderBy('id', 'DESC');
                $data = $res->get()->getResult();
                if ($data) {
                    for ($i = 0; $i < count($data); $i++) {
                        if (filter_var($data[$i]->profile, FILTER_VALIDATE_URL) === FALSE) {
                            // Not a valid URL. Its a image only or empty
                            $data[$i]->profile = (!empty($data[$i]->profile)) ? base_url() . '/public/images/profile/' . $data[$i]->profile : '';
                        }

                        $tbl = $this->db->table('tbl_comment_like');
                        $like = $tbl->select('COUNT(id) as total')->where('comment_id', $data[$i]->id)->where('status', '1')->get()->getResult();
                        $data[$i]->total_like = (!empty($like)) ? $like[0]->total : "0";

                        $dislike = $tbl->select('COUNT(id) as total')->where('comment_id', $data[$i]->id)->where('status', '2')->get()->getResult();
                        $data[$i]->total_dislike = (!empty($dislike)) ? $dislike[0]->total : "0";

                        $ulike = $tbl->where('comment_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '1')->get()->getResult();
                        $data[$i]->like = (!empty($ulike)) ? '1' : '0';

                        $udislike = $tbl->where('comment_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '2')->get()->getResult();
                        $data[$i]->dislike = (!empty($udislike)) ? '1' : '0';

                        $data[$i]->replay = $data3 = array();
                        $res = $this->db->table('tbl_comment c');
                        $res->select('c.*,u.name,u.profile');
                        $res->join('tbl_users u', 'u.id = c.user_id');
                        $res->where('c.news_id', $news_id)->where('c.parent_id', $data[$i]->id)->where('c.status', '1')->orderBy('id', 'ASC');
                        $data3 = $res->get()->getResult();
                        for ($j = 0; $j < count($data3); $j++) {
                            if (filter_var($data[$j]->profile, FILTER_VALIDATE_URL) === FALSE) {
                                // Not a valid URL. Its a image only or empty
                                $data3[$j]->profile = (!empty($data3[$j]->profile)) ? base_url() . '/public/images/profile/' . $data3[$j]->profile : '';
                            }
                            $like = $tbl->select('COUNT(id) as total')->where('comment_id', $data3[$j]->id)->where('status', '1')->get()->getResult();
                            $data3[$j]->total_like = (!empty($like)) ? $like[0]->total : "0";

                            $dislike = $tbl->select('COUNT(id) as total')->where('comment_id', $data3[$j]->id)->where('status', '2')->get()->getResult();
                            $data3[$j]->total_dislike = (!empty($dislike)) ? $dislike[0]->total : "0";

                            $ulike = $tbl->where('comment_id', $data3[$j]->id)->where('user_id', $user_id)->where('status', '1')->get()->getResult();
                            $data3[$j]->like = (!empty($ulike)) ? '1' : '0';

                            $udislike = $tbl->where('comment_id', $data3[$j]->id)->where('user_id', $user_id)->where('status', '2')->get()->getResult();
                            $data3[$j]->dislike = (!empty($udislike)) ? '1' : '0';
                        }
                        $data[$i]->replay = $data3;
                    }
                    $res = $this->db->table('tbl_comment c');
                    $res->select('c.*, u.name')->join('tbl_users u', 'u.id = c.user_id');
                    $res->where('c.news_id', $news_id)->where('c.status', '1');
                    $data1 = $res->get()->getResult();
                    $total = count($data1);

                    $response['error'] = "false";
                    $response['message'] = "Comment successfully";
                    $response['total'] = "$total";
                    $response['data'] = $data;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function get_news_by_id() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('news_id') && $this->request->getVar('user_id') != '') {
                $news_id = $this->request->getVar('news_id');
                $user_id = $this->request->getVar('user_id');

                $res = $this->db->table('tbl_news');
                $res->select('tbl_news.*, tbl_category.category_name');
                $res->join('tbl_category', 'tbl_category.id = tbl_news.category_id');
                $res->where('tbl_news.id', $news_id);
                $data = $res->get()->getResult();
                if ($data) {
                    for ($i = 0; $i < count($data); $i++) {
                        $data[$i]->image = ($data[$i]->image) ? base_url() . '/public/images/news/' . $data[$i]->image : '';
                        if ($data[$i]->content_type == "video_upload") {
                            $data[$i]->content_value = ($data[$i]->content_value) ? base_url() . '/public/images/news_video/' . $data[$i]->content_value : '';
                        }


                        $img = array();
                        $img = $this->db->table('tbl_news_image')->select('other_image')->where('news_id', $data[$i]->id)->get()->getResult();
                        for ($j = 0; $j < count($img); $j++) {
                            $img[$j]->other_image = ($img[$j]->other_image) ? base_url() . '/public/images/news/' . $data[$i]->id . '/' . $img[$j]->other_image : '';
                        }
                        $data[$i]->image_data = $img;

                        $like = $this->db->table('tbl_news_like')->select('COUNT(id) as total')->where('news_id', $data[$i]->id)->where('status', '1')->get()->getResult();
                        $data[$i]->total_like = (!empty($like)) ? $like[0]->total : "0";

                        $dislike = $this->db->table('tbl_news_like')->select('COUNT(id) as total')->where('news_id', $data[$i]->id)->where('status', '2')->get()->getResult();
                        $data[$i]->total_dislike = (!empty($dislike)) ? $dislike[0]->total : "0";

                        $ulike = $this->db->table('tbl_news_like')->where('news_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '1')->get()->getResult();
                        $data[$i]->like = (!empty($ulike)) ? '1' : '0';

                        $udislike = $this->db->table('tbl_news_like')->where('news_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '2')->get()->getResult();
                        $data[$i]->dislike = (!empty($udislike)) ? '1' : '0';

                        $query2 = $this->db->query('SELECT GROUP_CONCAT(distinct(tag_name)) as tag_name FROM tbl_tag WHERE id IN(' . $data[$i]->tag_id . ')');
                        $res2 = $query2->getResult();
                        $data[$i]->tag_name = (!empty($res2)) ? $res2[0]->tag_name : '';
                    }
                    $response['error'] = "false";
                    $response['data'] = $data;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function get_news_by_category() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if (($this->request->getVar('category_id') || $this->request->getVar('subcategory_id')) && $this->request->getVar('user_id') != '') {
                $category_id = ($this->request->getVar('category_id')) ? $this->request->getVar('category_id') : 0;
                $subcategory_id = ($this->request->getVar('subcategory_id')) ? $this->request->getVar('subcategory_id') : 0;
                $user_id = $this->request->getVar('user_id');

                $offset = ($this->request->getVar('offset')) ? $this->request->getVar('offset') : 0;
                $limit = ($this->request->getVar('limit')) ? $this->request->getVar('limit') : 10;

                $res = $this->db->table('tbl_news');
                $res->select('tbl_news.*,tbl_category.category_name');
                $res->join('tbl_category', 'tbl_news.category_id = tbl_category.id');
                $res->join('tbl_subcategory', 'tbl_news.subcategory_id = tbl_subcategory.id', 'left');
                if ($this->request->getVar('category_id')) {
                    $res->where('tbl_news.category_id', $category_id);
                } else {
                    $res->where('tbl_news.subcategory_id', $subcategory_id);
                }
                $res->limit($limit, $offset)->orderBy('id', 'DESC');
                $data = $res->get()->getResult();
                if ($data) {
                    $res1 = $this->db->table('tbl_news');
                    $res1->join('tbl_category', 'tbl_news.category_id = tbl_category.id');
                    $res1->join('tbl_subcategory', 'tbl_news.subcategory_id = tbl_subcategory.id', 'left');
                    if ($this->request->getVar('category_id')) {
                        $res1->where('tbl_news.category_id', $category_id);
                    } else {
                        $res1->where('tbl_news.subcategory_id', $subcategory_id);
                    }
                    $data1 = $res1->get()->getResult();
                    $total = count($data1);
                    for ($i = 0; $i < count($data); $i++) {
                        $data[$i]->image = ($data[$i]->image) ? base_url() . '/public/images/news/' . $data[$i]->image : '';
                        if ($data[$i]->content_type == "video_upload") {
                            $data[$i]->content_value = ($data[$i]->content_value) ? base_url() . '/public/images/news_video/' . $data[$i]->content_value : '';
                        }
                        $img = array();
                        $img = $this->db->table('tbl_news_image')->select('other_image')->where('news_id', $data[$i]->id)->get()->getResult();
                        for ($j = 0; $j < count($img); $j++) {
                            $img[$j]->other_image = ($img[$j]->other_image) ? base_url() . '/public/images/news/' . $data[$i]->id . '/' . $img[$j]->other_image : '';
                        }
                        $data[$i]->image_data = $img;

                        $like = $this->db->table('tbl_news_like')->select('COUNT(id) as total')->where('news_id', $data[$i]->id)->where('status', '1')->get()->getResult();
                        $data[$i]->total_like = (!empty($like)) ? $like[0]->total : "0";

                        $dislike = $this->db->table('tbl_news_like')->select('COUNT(id) as total')->where('news_id', $data[$i]->id)->where('status', '2')->get()->getResult();
                        $data[$i]->total_dislike = (!empty($dislike)) ? $dislike[0]->total : "0";

                        $ulike = $this->db->table('tbl_news_like')->where('news_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '1')->get()->getResult();
                        $data[$i]->like = (!empty($ulike)) ? '1' : '0';

                        $udislike = $this->db->table('tbl_news_like')->where('news_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '2')->get()->getResult();
                        $data[$i]->dislike = (!empty($udislike)) ? '1' : '0';

                        $query2 = $this->db->query('SELECT GROUP_CONCAT(distinct(tag_name)) as tag_name FROM tbl_tag WHERE id IN(' . $data[$i]->tag_id . ')');
                        $res2 = $query2->getResult();
                        $data[$i]->tag_name = (!empty($res2)) ? $res2[0]->tag_name : '';
                    }
                    $response['error'] = "false";
                    $response['total'] = "$total";
                    $response['data'] = $data;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function get_news() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id') != '') {
                $user_id = $this->request->getVar('user_id');
                $offset = ($this->request->getVar('offset')) ? $this->request->getVar('offset') : 0;
                $limit = ($this->request->getVar('limit')) ? $this->request->getVar('limit') : 10;

//                $res = $this->db->table('tbl_news');
//                $res->select('tbl_news.*, tbl_category.category_name, tbl_subcategory.subcategory_name');
//                $res->join('tbl_category', 'tbl_category.id = tbl_news.category_id', 'left');
//                $res->join('tbl_subcategory', 'tbl_subcategory.id = tbl_news.subcategory_id', 'left');
//                if ($this->request->getVar('search')) {
//                    $search = $this->request->getVar('search');
//                    $res->like('tbl_news.title', $search);
//                }
//                $res->limit($limit, $offset)->orderBy('id', 'DESC');
//                $data = $res->get()->getResult();

                $join = ' LEFT JOIN tbl_category ON tbl_category.id = tbl_news.category_id';
                $join .= ' LEFT JOIN tbl_subcategory ON tbl_subcategory.id = tbl_news.subcategory_id';

                if ($this->request->getVar('search')) {
                    $search = $this->request->getVar('search');
                    $where = " WHERE ( tbl_news.title like '%" . $search . "%')";
                }

                $query = $this->db->query('SELECT tbl_news.*, tbl_category.category_name, tbl_subcategory.subcategory_name FROM tbl_news' . $join . ' ' . $where . ' ORDER BY id DESC LIMIT ' . $offset . ',' . $limit . '');
                $data = $query->getResult();

                if ($data) {
//                    $res = $this->db->table('tbl_news');
//                    $res->select('tbl_news.*,tbl_category.category_name');
//                    $res->join('tbl_category', 'tbl_category.id = tbl_news.category_id', 'left');
//                    if ($this->request->getVar('search')) {
//                        $search = $this->request->getVar('search');
//                        $res->like('tbl_news.title', $search);
//                    }
//                    $data1 = $res->get()->getResult();
                    $query1 = $this->db->query('SELECT tbl_news.*, tbl_category.category_name, tbl_subcategory.subcategory_name FROM tbl_news ' . $join . ' ' . $where . ' ORDER BY id DESC');
                    $data1 = $query1->getResult();

                    $total = count($data1);
                    for ($i = 0; $i < count($data); $i++) {
                        $data[$i]->image = ($data[$i]->image) ? base_url() . '/public/images/news/' . $data[$i]->image : '';
                        if ($data[$i]->content_type == "video_upload") {
                            $data[$i]->content_value = ($data[$i]->content_value) ? base_url() . '/public/images/news_video/' . $data[$i]->content_value : '';
                        }
                        $img = array();
                        $img = $this->db->table('tbl_news_image')->select('other_image')->where('news_id', $data[$i]->id)->get()->getResult();
                        for ($j = 0; $j < count($img); $j++) {
                            $img[$j]->other_image = ($img[$j]->other_image) ? base_url() . '/public/images/news/' . $data[$i]->id . '/' . $img[$j]->other_image : '';
                        }
                        $data[$i]->image_data = $img;

                        $data[$i]->subcategory_name = ($data[$i]->subcategory_name != NULL) ? $data[$i]->subcategory_name : "";

                        $like = $this->db->table('tbl_news_like')->select('COUNT(id) as total')->where('news_id', $data[$i]->id)->where('status', '1')->get()->getResult();
                        $data[$i]->total_like = (!empty($like)) ? $like[0]->total : "0";

                        $dislike = $this->db->table('tbl_news_like')->select('COUNT(id) as total')->where('news_id', $data[$i]->id)->where('status', '2')->get()->getResult();
                        $data[$i]->total_dislike = (!empty($dislike)) ? $dislike[0]->total : "0";

                        $ulike = $this->db->table('tbl_news_like')->where('news_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '1')->get()->getResult();
                        $data[$i]->like = (!empty($ulike)) ? '1' : '0';

                        $udislike = $this->db->table('tbl_news_like')->where('news_id', $data[$i]->id)->where('user_id', $user_id)->where('status', '2')->get()->getResult();
                        $data[$i]->dislike = (!empty($udislike)) ? '1' : '0';

                        $query2 = $this->db->query('SELECT GROUP_CONCAT(distinct(tag_name)) as tag_name FROM tbl_tag WHERE id IN(' . $data[$i]->tag_id . ')');
                        $res2 = $query2->getResult();
                        $data[$i]->tag_name = (!empty($res2)) ? $res2[0]->tag_name : '';
                    }
                    $response['error'] = "false";
                    $response['total'] = "$total";
                    $response['data'] = $data;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function get_category() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            $offset = ($this->request->getVar('offset')) ? $this->request->getVar('offset') : 0;
            $limit = ($this->request->getVar('limit')) ? $this->request->getVar('limit') : 10;

            $data = $this->db->table('tbl_category')->limit($limit, $offset)->orderBy('id', 'DESC')->get()->getResult();
            if ($data) {
                $data1 = $this->db->table('tbl_category')->get()->getResult();
                $total = count($data1);
                for ($i = 0; $i < count($data); $i++) {
                    $data[$i]->image = ($data[$i]->image) ? base_url() . '/public/images/category/' . $data[$i]->image : '';
                    //$s_res = array();
                    $s_res = $this->db->table('tbl_subcategory')->where('category_id', $data[$i]->id)->get()->getResult();
//                    print_r($s_res);                 
                    $data[$i]->subcategory = $s_res;
                }
                $response['error'] = "false";
                $response['total'] = "$total";
                $response['data'] = $data;
            } else {
                $response['error'] = "true";
                $response['message'] = "No Data Found";
            }
        }
        return $this->respond($response);
    }

    public function get_breaking_news() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            $data = $this->db->table('tbl_breaking_news')->orderBy('id', 'DESC')->get()->getResult();
            if ($data) {
                for ($i = 0; $i < count($data); $i++) {
                    $data[$i]->image = ($data[$i]->image) ? base_url() . '/public/images/breaking_news/' . $data[$i]->image : '';
                    if ($data[$i]->content_type == "video_upload") {
                        $data[$i]->content_value = ($data[$i]->content_value) ? base_url() . '/public/images/breaking_news_video/' . $data[$i]->content_value : '';
                    }
                }
                $response['error'] = "false";
                $response['data'] = $data;
            } else {
                $response['error'] = "true";
                $response['message'] = "No Data Found";
            }
        }
        return $this->respond($response);
    }

    public function get_settings() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            $data = $this->db->table('tbl_settings')->get()->getResult();
            if ($data) {
                for ($i = 0; $i < count($data); $i++) {
                    $data1[$data[$i]->type] = $data[$i]->message;
                }
                $response['error'] = "false";
                $response['data'] = $data1;
            } else {
                $response['error'] = "true";
                $response['message'] = "No data found!";
            }
        }
        return $this->respond($response);
    }

    public function get_user_by_id() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id')) {
                $user_id = $this->request->getVar('user_id');

                $res = $this->db->table('tbl_users')->where('id', $user_id)->get()->getResult();
                if ($res) {
                    for ($i = 0; $i < count($res); $i++) {
                        if (filter_var($res[$i]->profile, FILTER_VALIDATE_URL) === FALSE) {
                            // Not a valid URL. Its a image only or empty
                            $res[$i]->profile = (!empty($res[$i]->profile)) ? base_url() . '/public/images/profile/' . $res[$i]->profile : '';
                        }
                        $cat = $this->db->table('tbl_users_category')->select('category_id')->where('user_id', $user_id)->get()->getResult();
                        $res[$i]->category_id = ($cat) ? $cat[0]->category_id : '';
                    }
                    $response['error'] = "false";
                    $response['data'] = $res;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function update_fcm_id() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id') && $this->request->getVar('fcm_id')) {
                $user_id = $this->request->getVar('user_id');
                $fcm_id = $this->request->getVar('fcm_id');

                $data['fcm_id'] = $fcm_id;
                $this->db->table('tbl_users')->where('id', $user_id)->update($data);

                $response['error'] = "false";
                $response['message'] = "updated successfully";
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function register_token() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('token')) {
                $token = $this->request->getVar('token');
                $data = $this->db->table('tbl_token')->where('token', $token)->get()->getResult();
                if (empty($data)) {
                    $data = ['token' => $token];
                    $this->db->table('tbl_token')->insert($data);
                    $response['error'] = "false";
                    $response['message'] = "Device registered successfully";
                } else {
                    $response['error'] = "true";
                    $response['message'] = "Device already registered";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function set_profile_image() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            $image = $this->request->getFile('image');
            if ($this->request->getVar('user_id') && $image->getClientName() != '') {
                if (!is_dir('public/images/profile')) {
                    mkdir('./public/images/profile', 0777, TRUE);
                }
                $user_id = $this->request->getVar('user_id');
                $data = $this->db->table('tbl_users')->where('id', $user_id)->get()->getResult();
                if ($data[0]->profile != "") {
                    if (file_exists('public/images/profile/' . $data[0]->profile)) {
                        unlink('public/images/profile/' . $data[0]->profile);
                    }
                }
                $newName = microtime(TRUE) . '.' . $image->getClientExtension();
                if ($image->isValid() && !$image->hasMoved()) {
                    $image->move('public/images/profile', $newName);
                }
                if ($image->hasMoved()) {
                    $data = ['profile' => $newName];
                    $this->db->table('tbl_users')->where('id', $user_id)->update($data);
                    $response['error'] = "false";
                    $response['message'] = 'File uploaded successfully!';
                    $response['file_path'] = base_url() . '/public/images/profile/' . $newName;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "Could not move the file!";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function update_profile() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id')) {
                $user_id = $this->request->getVar('user_id');

                $data = array();
                if ($this->request->getVar('name')) {
                    $name = $this->request->getVar('name');
                    $data['name'] = $name;
                }
                if ($this->request->getVar('mobile')) {
                    $mobile = $this->request->getVar('mobile');
                    $data['mobile'] = $mobile;
                }
                if ($this->request->getVar('email')) {
                    $email = $this->request->getVar('email');
                    $data['email'] = $email;
                }

                $this->db->table('tbl_users')->where('id', $user_id)->update($data);

                $response['error'] = "false";
                $response['message'] = "Profile updated successfully";
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function user_signup() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('firebase_id') && $type = $this->request->getVar('type')) {
                $firebase_id = $this->request->getVar('firebase_id');
                $email = ($this->request->getVar('email')) ? $this->request->getVar('email') : "";
                $type = $this->request->getVar('type');
                $name = ($this->request->getVar('name')) ? $this->request->getVar('name') : "";
                $mobile = ($this->request->getVar('mobile')) ? $this->request->getVar('mobile') : "";
                $status = ($this->request->getVar('status')) ? $this->request->getVar('status') : "1";
                $profile = ($this->request->getVar('profile')) ? $this->request->getVar('profile') : "";
                $fcm_id = ($this->request->getVar('fcm_id')) ? $this->request->getVar('fcm_id') : "";

                $res = $this->db->table('tbl_users')->where('firebase_id', $firebase_id)->get()->getResult();

                if (empty($res)) {
                    $data = [
                        'firebase_id' => $firebase_id,
                        'name' => $name,
                        'email' => $email,
                        'mobile' => $mobile,
                        'type' => $type,
                        'profile' => $profile,
                        'status' => $status,
                        'date' => $this->toDateTime,
                        'fcm_id' => $fcm_id
                    ];
                    $this->db->table('tbl_users')->insert($data);
                    $insert_id = $this->db->insertID();
                    $data1 = $this->db->table('tbl_users')->where('id', $insert_id)->get()->getResult();
                    $data1[0]->is_login = '1';
                    $response['error'] = "false";
                    $response['message'] = "User Registered successfully";
                    $response['data'] = $data1[0];
                } else {
                    if (!empty($fcm_id)) {
                        $data = ['fcm_id' => $fcm_id];
                        $this->db->table('tbl_users')->where('firebase_id', $firebase_id)->update($data);
                        $res = $this->db->table('tbl_users')->where('firebase_id', $firebase_id)->get()->getResult();
                    }

                    for ($i = 0; $i < count($res); $i++) {
                        if (filter_var($res[$i]->profile, FILTER_VALIDATE_URL) === FALSE) {
                            // Not a valid URL. Its a image only or empty
                            $res[$i]->profile = (!empty($res[$i]->profile)) ? base_url() . '/public/images/profile/' . $res[$i]->profile : '';
                        }
                        $res[$i]->is_login = '0';
                    }
                    $response['error'] = "false";
                    $response['message'] = "Successfully logged in";
                    $response['data'] = $res[0];
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function generate_token() {
        $payload = [
            'iat' => time(), /* issued at time */
            'iss' => 'NewsAPP',
            'exp' => time() + (30 * 60 * 60 * 24), /* expires after 1 minute */
            'sub' => 'News APP Authentication'
        ];
        return JWT::encode($payload, $this->JWT_KEY);
    }

    public function verify_token() {
        try {
            $token = JWT::getBearerToken();
        } catch (\Exception $e) {
            $response['error'] = "true";
            $response['message'] = $e->getMessage();
            return $this->respond($response);
        }
        if (!empty($token)) {
            try {
                $payload = JWT::decode($token, $this->JWT_KEY, ['HS256']);
                if (!isset($payload->iss) || $payload->iss != 'NewsAPP') {
                    $response['error'] = "true";
                    $response['message'] = 'Invalid Hash';
                    return $this->respond($response);
                }
            } catch (\Exception $e) {
                $response['error'] = "true";
                $response['message'] = $e->getMessage();
                return $this->respond($response);
            }
        } else {
            $response['error'] = "true";
            $response['message'] = "Unauthorized access not allowed";
            return $this->respond($response);
        }
    }

    public function get_question() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id')) {
                $offset = ($this->request->getVar('offset')) ? $this->request->getVar('offset') : 0;
                $limit = ($this->request->getVar('limit')) ? $this->request->getVar('limit') : 10;

                $user_id = $this->request->getVar('user_id');
                $chk_que = $this->db->table('tbl_survey_result')->where('user_id', $user_id)->get()->getResult();
                $val = '';

                if ($chk_que) {
                    $question = array();
                    for ($k = 0; $k < count($chk_que); $k++) {
                        $question[$k] = $chk_que[$k]->question_id;
                    }
                    $val = implode(',', $question);
                }

                $where = "WHERE status='1' ";
                if ($val != '') {
                    $where .= " AND id NOT IN ($val)";
                }
                $query = $this->db->query("SELECT * FROM tbl_survey_question $where ORDER BY id DESC LIMIT $offset ,$limit");
                $data = $query->getResult();
                if ($data) {
                    $query1 = $this->db->query("SELECT * FROM tbl_survey_question $where ORDER BY id DESC");
                    $data1 = $query1->getResult();

                    $total = count($data);
                    for ($i = 0; $i < count($data); $i++) {

                        $option = array();
                        $option = $this->db->table('tbl_survey_option')->where('question_id', $data[$i]->id)->get()->getResult();
                        for ($j = 0; $j < count($option); $j++) {
                            $option[$j]->options = ($option[$j]->options) ? $option[$j]->options : '';
                        }
                        $data[$i]->option = $option;
                    }
                    $response['error'] = "false";
                    $response['total'] = "$total";
                    $response['data'] = $data;
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

    public function set_question_result() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {

            if ($this->request->getVar('question_id') && $this->request->getVar('option_id') && $this->request->getVar('user_id')) {
                $question_id = $this->request->getVar('question_id');
                $option_id = $this->request->getVar('option_id');
                $user_id = $this->request->getVar('user_id');

                $data = [
                    'user_id' => $user_id,
                    'question_id' => $question_id,
                    'option_id' => $option_id,
                ];
                $this->db->table('tbl_survey_result')->insert($data);

                $get_val = $this->db->table('tbl_survey_option')->where('id', $option_id)->get()->getResult();
                $counter = ($get_val[0]->counter) + 1;

                $data2 = [
                    'counter' => $counter,
                ];
                $this->db->table('tbl_survey_option')->where('id', $option_id)->update($data2);

                $response['error'] = "false";
                $response['message'] = "Data inserted successfully";
            } else {
                $response['error'] = "true";
                $response['message'] = "No Data Found";
            }
        }
        return $this->respond($response);
    }

    public function get_question_result() {
        if ($this->verify_token()) {
            return $this->verify_token();
        }
        if ($this->access_key != $this->request->getVar('access_key')) {
            $response['error'] = "true";
            $response['message'] = "Invalid Access Key";
        } else {
            if ($this->request->getVar('user_id')) {
                $offset = ($this->request->getVar('offset')) ? $this->request->getVar('offset') : 0;
                $limit = ($this->request->getVar('limit')) ? $this->request->getVar('limit') : 10;

                $user_id = $this->request->getVar('user_id');
                $chk_que = $this->db->table('tbl_survey_result')->where('user_id', $user_id)->get()->getResult();
                $val = '';

                if ($chk_que) {
                    $question = array();
                    for ($k = 0; $k < count($chk_que); $k++) {

                        $question[$k] = $chk_que[$k]->question_id;
                    }

                    $val = implode(',', $question);

                    $where = "WHERE status='1' ";
                    if ($val != '') {
                        $where .= " AND id IN ($val)";
                    }
                    $query = $this->db->query("SELECT * FROM tbl_survey_question $where ORDER BY id DESC LIMIT $offset ,$limit");
                    $data = $query->getResult();
                    if ($data) {
                        $query1 = $this->db->query("SELECT * FROM tbl_survey_question $where ORDER BY id DESC");
                        $data1 = $query1->getResult();

                        $total = count($data);
                        for ($i = 0; $i < count($data); $i++) {

                            $get_user = $this->db->table('tbl_survey_result')->where('question_id', $data[$i]->id)->get()->getResult();
                            $total_user = count($get_user);

                            $option = array();
                            $option = $this->db->table('tbl_survey_option')->select('options,counter')->where('question_id', $data[$i]->id)->get()->getResult();

                            for ($j = 0; $j < count($option); $j++) {
                                $option[$j]->options = ($option[$j]->options) ? $option[$j]->options : '';
                                $option[$j]->counter = ($option[$j]->counter) ? $option[$j]->counter : '0';
                                $per = $option[$j]->counter * 100 / $total_user;
                                $per = round($per, 2);
                                $option[$j]->percentage ="$per";
                            }
                            $data[$i]->option = $option;
                        }
                        $response['error'] = "false";
                        $response['total'] = "$total";
                        $response['data'] = $data;
                    } else {
                        $response['error'] = "true";
                        $response['message'] = "No Data Found";
                    }
                } else {
                    $response['error'] = "true";
                    $response['message'] = "No Data Found";
                }
            } else {
                $response['error'] = "true";
                $response['message'] = "Please fill all the data and submit!";
            }
        }
        return $this->respond($response);
    }

}
