<!DOCTYPE html>
<html lang="en">
    <head>
        <?php base_url() . include 'include.php'; ?>  
        <title>Login | <?= ($app_name) ? $app_name[0]->message : '' ?></title>
    </head>

    <body class="hold-transition login-page">
        <div class="login-box">

            <!-- /.login-logo -->
            <div class="card">

                <div class="card-body login-card-body">
                    
                    <div class="login-logo">
                        <a href="javascript:void(0)">
                            <img src="<?= APP_URL ?>public/images/<?= $app_logo_full[0]->message ?>" alt="image" width="300"/>
                        </a>
                    </div>
                    
                    <p class="login-box-msg">Login</p>                   

                    <form role="form" id ="login_form" action="<?= base_url(); ?>/checklogin" method="post">
                        <?= csrf_field() ?>
                        <div class="form-group">
                            <input type="text" name="username" class="form-control" id="exampleInputUsername1" placeholder="Usename">
                        </div>
                        <div class="form-group">
                            <input type="password" name="password" class="form-control" id="exampleInputPassword1" placeholder="Password">
                        </div>
                        <?php
                        $this->session = \Config\Services::session();
                        $this->session->start();
                        if ($this->session->getFlashdata('error')) {
                            ?>
                            <div class="row col-12">
                                <p id="error_msg" class="alert alert-danger"><?php echo $this->session->getFlashdata('error'); ?></p>
                            </div>  
                        <?php } ?> 
                        <div class="row float-right">
                            <div class="col-12">
                                <button type="submit" class="btn btn-primary btn-block">Login</button>
                            </div>
                        </div>
                    </form>

                </div>
            </div>
        </div>

        <!-- jQuery -->

        <script src="<?= base_url(); ?>/public/plugins/jquery/jquery.min.js"></script>
        <!-- Bootstrap 4 -->
        <script src="<?= base_url(); ?>/public/plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
        <!-- Admin App -->        
        <script src="<?= base_url(); ?>/public/dist/js/adminlte.min.js"></script>
        <!-- Validadtion js -->
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.2/jquery.validate.js"></script>

        <script>
            $(document).ready(function () {
                $('#error_msg').delay(4000).fadeOut();
            });
        </script>
        <script type="text/javascript">
            $(document).ready(function () {
                $('#login_form').validate({
                    rules: {
                        username: {required: true},
                        password: {required: true}
                    },
                    messages: {
                        username: {required: "Please enter username"},
                        password: {required: "Please enter password"}
                    },
                    errorElement: 'span',
                    errorPlacement: function (error, element) {
                        error.addClass('invalid-feedback');
                        element.closest('.form-group').append(error);
                    },
                    highlight: function (element, errorClass, validClass) {
                        $(element).addClass('is-invalid');
                    },
                    unhighlight: function (element, errorClass, validClass) {
                        $(element).removeClass('is-invalid');
                    }
                });
            });
        </script>
    </body>
</html>

